#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

void printstat(char *prefix, char *fn, struct stat *st)
{
	printf("Stats on %s %s: %d\n", prefix, fn, stat(fn, st));
/*	printf(" dev/ino: %d/%d\n", st->st_dev, st->st_ino); */
	printf(" mode=%o\n", st->st_mode);
	printf(" nlink=%d\n", st->st_nlink);
	printf(" size=%d\n", st->st_size);
}

int main()
{
	FILE *f;
	int fd;
	char *tmp = "tmp";
	char *dev = "/dev/null";
	struct stat st;
	time_t t[2];

	/* plain old file and umask */
	printf("umask: %d\n", umask(~0610));
	printf("umask: %d\n", umask(~0610));
	unlink(tmp);
	f = fopen(tmp, "w");
	fd = fileno(f);
	write(fd, "1234", 4);
	printstat("file", tmp, &st);

/* the system call fails on my system, even via gnu libc
	printf("utime: %d\n", utime(tmp, t));
	printf("t[0] matches %d:\n", t[0] == st.st_atime);
	printf("t[1] matches %d:\n", t[1] == st.st_mtime);

	printf("%s\n", ctime(&t[0]));
	printf("%s\n", ctime(&t[1]));
*/

	/* specials */
	printstat("device", dev, &st);
	printstat("dir", "/", &st);
	printstat("nonexistent", "/foobar", &st);

	fclose(f);
}
