/*
 * ttyname(f): return "/dev/ttyXX" which the the name of the
 * tty belonging to file f.
 *  NULL if it is not a tty
 */

#define	NULL	0
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <v7libc_internal.h>

static	char	*devs[]	= {"/dev/", "/dev/pts/", NULL};
char	*strcpy();
char	*strcat();

char *
ttyname(f)
{
	struct stat fsb;
	struct stat tsb;
	static char rbuf[32];
	register df;
	_v7libc_dirent_t *de;
	void *cookie;
	char **dev;

	if (isatty(f)==0)
		return(NULL);
	if (fstat(f, &fsb) < 0)
		return(NULL);
	if ((fsb.st_mode&S_IFMT) != S_IFCHR)
		return(NULL);

	for(dev = devs; *dev != NULL; dev++) {
		if ((df = open(*dev, 0)) < 0)
			continue;
		_v7libc_dirstart(&cookie, df);
		while ((de = _v7libc_dirnext(cookie)) != NULL) {
			if (de->ino == 0)
				continue;
			if (de->ino != fsb.st_ino)
				continue;
			strcpy(rbuf, *dev);
			strcat(rbuf, de->name);
			if (stat(rbuf, &tsb) < 0)
				continue;
			if (tsb.st_dev==fsb.st_dev && tsb.st_ino==fsb.st_ino) {
				_v7libc_dirend(&cookie);
				close(df);
				return(rbuf);
			}
		}
		_v7libc_dirend(&cookie);
		close(df);
	}
	return(NULL);
}
